<?php

class QFrontController
{
	public function __construct ()
	{

		/**
		* In $_SERVER['PATH_INFO'] staat de tekst achter de bestandsnaam.
		* Voorbeeldje: index.php/guestbook/showlist, dan is PATH_INFO /guestbook/showlist.
		*/

		if ( isset ( $_SERVER['PATH_INFO'] ) )
		{

			$parts = explode ( '/', strtolower ( trim ( $_SERVER['PATH_INFO'], '/' ) ) );
			/**
			* $parts is nu dan dus array ( [0] => 'guestbook', [1] => 'showlist' );
			*/
			
			$controller = ( current ( $parts ) ) ? array_shift ( $parts ) : 'default';
			$action = (current ( $parts ) ) ? array_shift ( $parts ) : 'index';

			/** De overige gegevens zouden nu opgeslagen kunnen worden in een request object. */
		}

		else
		{
			$controller = 'default';
			$action = 'index';
		}

		$this -> dispatch ( $controller, $action );

	}


	public function dispatch ( $controller, $action )
	{
		if ( file_exists ( $controller . 'controller.php' ) ) {

			/** Het verwachtte bestand bestaat (guestbookcontroller.php). */
			require_once ( $controller . 'controller.php' );

			$controllername = ucfirst ( $controller ) . 'Controller';

			if ( class_exists ( $controllername ) ) { // bestaat GuestbookController?

				if ( in_array ( $action, get_class_methods ( $controllername ) ) ) {

					/** Actie bestaat ook, dus uitvoeren. */
					
					$controllerobject = new $controllername ();					
					$controllerobject -> $action ();
					
					/** Actie uitgevoerd. Afsluiten! */					
					return;
				}
			}
		}

		/** Oh oh, het bestand, de klasse, of de methode is niet gevonden. */
		die ( "Verkeerde parameters. Ongeldige controller. Vier nul vier, dus" );
	}
}

?>